
UNIT muis256;

INTERFACE
USES CRT, DOS;

CONST mouseint = $33;

TYPE  cursorray = ARRAY [0..33] OF LONGINT;
{CONST wijzertje : cursorray =
                (8,8,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,
                $0000,$0000,$0000,$0000,$FFFF,$FFFF,$FFFF,$700E,$F81F,$77EE,
                $1FF8,$318C,$2C34,$2DB4,$6DB6,$FE7F,$9819,$4FF2,$2004,$1FF8,
                $0000,$0000,$0000);}

VAR regs: registers;

function mouseavail: BYTE;
procedure resetmouse;
procedure resetmousetotaal;
procedure showmouse;
procedure hidemouse;
procedure getmouse (VAR knoppen, X, Y: WORD);
procedure setmouse (X, Y: WORD);
procedure setmousex (min, max: WORD);
procedure setmousey (min, max: WORD);
procedure grafischecursor (cursor: cursorray);
procedure setcursor (ctype, startlijn, eindlijn: WORD);
procedure mousespeed (vx,vy: INTEGER);
procedure mousesense (sensex, sensey: INTEGER);
procedure getmousesense (VAR horiz, vert, double: WORD);
procedure setmousesense (VAR horiz, vert, double: WORD);

IMPLEMENTATION

{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
FUNCTION mouseavail: BYTE; {muis aanwezig ?}
BEGIN
 regs.AX := 0;
 regs.BX := 0;
 INTR (mouseint,regs);
 IF regs.AX = $FFFF THEN mouseavail := regs.BX
 ELSE
 mouseavail := 0;
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE resetmouse; {reset mouse}
BEGIN
 regs.AX := 33; {initialseert alleen de muisdriver}
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE resetmousetotaal; {initialiseert de muisdriver EN de muis zelf}
BEGIN
 regs.AX := 0;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE showmouse; {muiscursor aan}
BEGIN
 regs.AX := 1;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE hidemouse; {muiscursor uit}
BEGIN
 regs.AX := 2;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE getmouse (VAR knoppen, X, Y: WORD); {leest muisklik en plaats}
BEGIN
 regs.AX := 3;
 INTR (mouseint,regs);
 knoppen := regs.BX; {1 = links/2 = rechts/3 = middelste}
 X       := regs.CX; {x-coordinaat in pixels}
 Y       := regs.DX; {y-coordinaat in pixels}
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE setmouse (X, Y: WORD); {plaatst de muiscursor op coordinaat x,y}
BEGIN
 regs.AX := 4;
 regs.CX := X;
 regs.DX := Y;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE setmousex (min, max: WORD); {stelt horizontale breedte in}
BEGIN
 regs.AX := 7;
 regs.CX := min;
 regs.DX := max;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE setmousey (min, max: WORD); {stelt vertikale breedte in}
BEGIN
 regs.AX := 8;
 regs.CX := min;
 regs.DX := max;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE grafischecursor (cursor: cursorray); {zie voorbeeld listing}
VAR cvar: ARRAY [0..31] OF INTEGER;
       i: INTEGER;
BEGIN
 FOR i := 0 TO 31 DO cvar[i] := cursor[i + 2];
 regs.AX := 9;
 regs.BX := cursor[0];
 regs.CX := cursor[1];
 regs.DX := OFS (cvar);
 regs.ES := SEG (cvar);
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE setcursor (ctype, startlijn, eindlijn: WORD); {zie voorbeeld listing}
BEGIN
 regs.AX := 10;
 regs.BX := ctype;
 regs.CX := startlijn;
 regs.DX := eindlijn;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE mousespeed (vx, vy: INTEGER); {stelt bewegings-snelheid in}
BEGIN
 regs.AX := 11;
 INTR (mouseint,regs);
 vx := regs.CX;
 vy := regs.DX;
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE mousesense (sensex, sensey: INTEGER); {stelt gevoeligheid in}
BEGIN                                           {sensx en -y moet 5-10}
 regs.AX := 15;
 regs.CX := sensex;
 regs.DX := sensey;
 IF (sensex <> 0) AND (sensey <> 0) THEN INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE setmousesense (VAR horiz, vert, double: WORD);
BEGIN
 regs.AX := 26;
 regs.BX := horiz;   {weet ik niet meer waar die vandaan komen}
 regs.CX := vert;
 regs.DX := double;
 INTR (mouseint,regs);
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}
PROCEDURE getmousesense (VAR horiz, vert, double: WORD);
BEGIN
 regs.AX := 27;
 INTR (mouseint,regs);
 horiz  := regs.BX;  {weet ik niet meer waar die vandaan komen}
 vert   := regs.CX;
 double := regs.DX;
END;
{KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK}

END.